Also send mention notifications to self
Closed, InvalidPublic3 Story Points

Description

Current Situation: Currently, if users make a mention to themselves, the mention is not sent. However, the reason for mentioning yourself might be either because you really wanted to be mentioned yourself or because it was a Freudian slip. In both cases it would be good to get notified.

Task: Allow mentions to self.
Pointers to the code can be found here: https://www.mediawiki.org/wiki/Help:Notifications#Mentions

Background: This task is based on a wish that received 21 points (#9) in the German Community Wishlist[1]. Originally, the wish was to receive an information about the sent messages. To keep the number of notifications smaller, and to help people use mentions in a way that they are sent, the task informs about mention failures, and adds the reasons for the failure as well.

[1] Link to wish (in German): https://de.wikipedia.org/wiki/Wikipedia:Umfragen/Technische_W%C3%BCnsche_2015/Topw%C3%BCnsche#Bei_Speichern_Hinweis_.C3.BCber_abgegebene_Benachrichtigungen_.5BUmfrage_2015.5D
in English: https://meta.wikimedia.org/wiki/WMDE_Technical_Wishes#Notifications_about_failed_mentions

There are a very large number of changes, so older changes are hidden. Show Older Changes
Addshore claimed this task.
Addshore triaged this task as Normal priority.Jun 22 2016, 2:39 PM
Tobi_WMDE_SW set the point value for this task to 3.Jun 29 2016, 11:44 AM
Tobi_WMDE_SW moved this task from Review to Doing on the TCB-Team-Sprint-2016-06-29 board.
Addshore moved this task from Backlog to Needs Review on the User-Addshore board.

Just to be double sure: The patch for this task already includes the part that we do not send mentions to user links in signatures, right?

Restricted Application added a project: Collaboration-Team-Triage. · View Herald TranscriptAug 2 2016, 10:47 AM

I'm sure there is a good reason why users need to mention themselves, but can someone please let me know what it is?

Trizek-WMF added a subscriber: Trizek-WMF.

I'm sure there is a good reason why users need to mention themselves, but can someone please let me know what it is?

I see two possible cases:

  • you are roughly copying/pasting a list of users, for example users involved in a wiki project in order to mention them.
  • you want to know if notifications have been sent, by including yourself to the list of names you mention.

Do you plan to deploy it on all wikis or just a small cluster of volunteer wikis? And when? It hasn't been merged on 1.28.0-wmf.14 yet.

Do you plan to deploy it on all wikis or just a small cluster of volunteer wikis? And when? It hasn't been merged on 1.28.0-wmf.14 yet.

The current plan was to have this roll out on wikis as a regular deployment.
So after it was merged, the test on the Tuesday, non wikipedias on the Wednesday and wikipedias on the Thursday (roughly speaking)

Triaged to be announced in next Tech News, then.

Documentation will be updated next week, I guess.

Johan added a subscriber: Johan.Aug 4 2016, 6:49 PM

I see this has been discussed, but for clarification: Will this happen next week (1.28.0-wmf.14)? Or will it be rolled out at a later date?

Catrope added a subscriber: Catrope.Aug 4 2016, 6:53 PM

I see this has been discussed, but for clarification: Will this happen next week (1.28.0-wmf.14)? Or will it be rolled out at a later date?

If @jmatazzoni approves then yes, wmf14.

Johan added a comment.Aug 4 2016, 8:06 PM

OK, I'll include it in Tech News as soon as it has been approved here, then. (:

Luke081515 renamed this task from Also send notifications to self to Also send mention-notifications to self.Aug 4 2016, 8:20 PM
Catrope renamed this task from Also send mention-notifications to self to Also send mention notifications to self.Aug 4 2016, 8:32 PM

OK, I'll include it in Tech News as soon as it has been approved here, then. (:

I got the green light, and I've just +2ed this. If nothing crazy happens, this will be in wmf14.

Change 295489 merged by jenkins-bot:
Allow self mentions

https://gerrit.wikimedia.org/r/295489

@Johan yes, this is not opt-in

Clpo13 added a subscriber: Clpo13.Aug 11 2016, 10:05 PM

Can this be made optional? Users of tools like Huggle and Twinkle on enwiki are getting constant notifications when they warn users as the default warning templates include a link to the user giving the warning.

JJMC89 added a subscriber: JJMC89.Aug 11 2016, 10:26 PM

Example templates which use {{REVISIONUSER}} to make code like "I'm [[User:PrimeHunter|PrimeHunter]]" when they are substituted, also in manual edits:
https://en.wikipedia.org/wiki/Template:Welcome_to_Wikipedia
https://en.wikipedia.org/wiki/Template:Huggle/warn-delete-1

Notifications for such self mentions are very unpopular at https://en.wikipedia.org/wiki/Wikipedia:Village_pump_(technical)#Strange_notifications

If these notifications are not stopped then many template messages must be recoded to avoid them.

For what it's worth, I think https://en.wikipedia.org/w/index.php?title=Template:Welcome_to_Wikipedia&oldid=711330911 is pretty bad and should be re-done for other reasons. The user link is the least of the concerns; it looks like a parody of a welcome message. Are we really subjecting new users to this?

Example templates which use {{REVISIONUSER}} to make code like "I'm [[User:PrimeHunter|PrimeHunter]]" when they are substituted, also in manual edits:
[...]
If these notifications are not stopped then many template messages must be recoded to avoid them.

I think the real issue here is that Echo decided to re-use/steal/add a purpose to/add a behavior to regular link syntax (i.e., [[User:Example]]). If we switched to a parser function such as {{#ping:user}}, we wouldn't have this issue; cf. https://www.mediawiki.org/wiki/User:Legoktm/pings.

Switching to a parser function still would not allow users to opt out of self-mentions.

I remain unconvinced that the use-cases for having self-mentions are valid. Quoting a previous comment:

I'm sure there is a good reason why users need to mention themselves, but can someone please let me know what it is?

I see two possible cases:

  • you are roughly copying/pasting a list of users, for example users involved in a wiki project in order to mention them.

If you are copying/pasting a list of users, you probably (read: hopefully) are already aware of whatever you're notifying others about.

  • you want to know if notifications have been sent, by including yourself to the list of names you mention.

Again, I'll point to https://www.mediawiki.org/wiki/User:Legoktm/pings. Please read this proposal. The issue of pings being unreliable is very real, but likely isn't solved by having self-mentions.

If there are not other valid use-cases for self-mentions presented, I suggest pulling back this feature, at least temporarily.

Quiddity added a subscriber: matmarex.

They're working on turning it off, right now.

Due to the issues with accidental self-mentions with templates (see above), I've disabled this pending further investigation and discussion. See also T142798: False "You mentioned yourself" notification.

I reverted it (rECHO59568789fa69: Revert "Allow self mentions"), since this one is not gated by a feature flag.

Danny_B added a subscriber: Danny_B.

↑ since it will need another notifice obviously as it was already noticed to be turned on in https://meta.wikimedia.org/wiki/Tech/News/2016/32

I think the real issue here is that Echo decided to re-use/steal/add a purpose to/add a behavior to regular link syntax (i.e., [[User:Example]]). If we switched to a parser function such as {{#ping:user}}, we wouldn't have this issue; cf. https://www.mediawiki.org/wiki/User:Legoktm/pings.

Nothing but true...
+1

Okay, this is something that we did not foresee.
It sounds like it would be best to hold off on this until such a time that mentions are not just links in text but some other format!

Lea_WMDE closed this task as Invalid.Aug 15 2016, 4:05 PM
Lea_WMDE added a subscriber: Legoktm.

Having discussed what happened on Friday, we (TCB-Team) decided to not pursue with enabling self mentions. Templates right now are too dependent on the self-mentioning not working, and it would take much more effort than expected to switch to allowing self mentions. From our side this is, as @MZMcBride stated, another case showing that a parser function like @Legoktm's proposal would probably a good long term strategy and if anyone picks this up, we are happy to pitch in!

Pine added a subscriber: Pine.EditedSep 6 2016, 8:48 PM

I was looking forward to this functionality for test notifications, although I understand the reasons for disabling the functionality. Is there now any way for a user to send themselves a test notification?

I was looking forward to this functionality for test notifications, although I understand the reasons for disabling the functionality. Is there now any way for a user to send themselves a test notification?

A alternate test-account is generally used for these sorts of things. E.g. I log into a second browser, with https://meta.wikimedia.org/wiki/User:Quiddity_II which has (frequently-reset) default preferences. Test-accounts are permissible alternate accounts, as long as they are identified as such.

Pine added a comment.Sep 6 2016, 9:22 PM

Thanks for the suggestion. Unfortunately that's more complicated than the arrangement I would like to see. My hope is for new users to be able to ping themselves with a test notification so that they can see how notifications work. Are there any other options for helping new users to test notifications without using multiple accounts? At some point I might write a bot that helps users to learn how notifications work, but without that bot and without users having the ability to ping themselves, I feel like the training for newbies about notifications is less robust than it should be.

@Pine We are also currently developing T139962: When saving, be informed about mentions you sent (#9), which creates two new opt-in features in your notification settings. One of them is to receive a notification whenever you successfully sent out a mention. This could make it unnecessary to send out test mentions, since you know that it worked the moment you received the notification. If all goes well, the feature will be enabled this Friday :)

Pine added a comment.Sep 16 2016, 9:37 PM

@Lea_WMDE Thanks, that will certainly be better than having no ability for the user to test notifications. I see that https://phabricator.wikimedia.org/T145390 says that the feature is being deployed this week. Will there be a failure notification if the user attempts to mention themselves? I wonder if users would get flooded with failure notifications if they use a lot of warning templates via Huggle or Twinkle, as noted above.

Hi @Pine
Mention notifications (regarding success and failures) are already deployed everywhere.
Just take a look at your notification preferences.
Give it a test and any feedback is welcome!

Pine added a comment.EditedSep 16 2016, 10:03 PM

@Addshore thanks. Unfortunately this feature isn't generating a failure notification when I attempt to ping myself on a Commons talk page. Also, I can't seem to get a failure notification when I ping another user and don't add my signature. I have commented in T135717#2644682.

@Pine these do not meet the criteria that is needed to class the edit as a 'failed mention'.
In order to even qualify as a potential mention the edit must have a signature, otherwise every edit that included a user link may be counted as a failed mention.
Also for exactly the reason you described above self mentions do not trigger a mention failure, you will never be mentioned by yourself.

The cases this feature tries to cover include adding multiple sections while trying to mention, editing text rather than adding text etc.

Pine added a comment.EditedSep 16 2016, 10:10 PM

OK. Not notifying the user about the signature requirement seems like a significant omission to me, particularly if the user uses the format {{ping|username}} which strongly indicates that the user intended to ping someone. Still, notification about a successful ping is more useful for my use case than no notification at all, so I will just accept this for the moment. Thanks.

Pine added a comment.Sep 16 2016, 10:16 PM

Further thought for future feature development:

  1. New users (emphasis on *new* users) could have these notifications about successful and failed mentions enabled by default, and also be given a prominent option to disable them.
  1. New users' edits to talk pages (emphasis on *new* users) could be tested before saving to see if the edits included the users' signature (via --~~~~ or similar). If the users didn't sign their posts, the user could be prompted to sign the post before saving it. The user could also be given a prominent option to disable the prompt.

The {{Ping template strongly indicates that the user intended to ping someone on the english wikipedia.
Other wikipedias use different templates or none at all.
The only real case to check for is a user link, which means right now the only way to program this notification would be, every edit that includes a user link but no signature send a notification saying that the user should have signed, which in 99% of cases was likely not their intention anyway.

T128535 would solve the issue of intent to mention.

After this I expect mention failure notifications could likely be enabled by default without much push back.

As for users forgetting to sign, this could perhaps be something different, but Flow has been moving forward in leaps and bounds in my opinion and I would rather see it take over talk pages.